]> git.donarmstrong.com Git - deb_pkgs/autorandr.git/blob - autorandr
Fix some typo errors
[deb_pkgs/autorandr.git] / autorandr
1 #!/bin/sh
2 #
3 # Automatically select a display configuration based on connected devices
4 #
5 # Stefan Tomanek <stefan.tomanek@wertarbyte.de>
6 #
7 # How to use:
8 #
9 # Save your current display configuration and setup with:
10 #  $ autorandr --save mobile
11 #
12 # Connect an additional display, configure your setup and save it:
13 #  $ autorandr --save docked
14 #
15 # Now autorandr can detect which hardware setup is active:
16 #  $ autorandr
17 #    mobile
18 #    docked (detected)
19 #
20 # To automatically reload your setup, just append --change to the command line
21 #
22 # To manually load a profile, you can use the --load <profile> option.
23 #
24 # autorandr tries to avoid reloading an identical configuration. To force the
25 # (re)configuration, apply --force.
26 #
27 # To prevent a profile from being loaded, place a script call "block" in its
28 # directory. The script is evaluated before the screen setup is inspected, and
29 # in case of it returning a value of 0 the profile is skipped. This can be used
30 # to query the status of a docking station you are about to leave.
31 #
32 # If no suitable profile can be identified, the current configuration is kept.
33 # To change this behaviour and switch to a fallback configuration, specify
34 # --default <profile>
35 #
36 # Another script called "postswitch "can be placed in the directory
37 # ~/.autorandr as well as in all profile directories: The scripts are executed
38 # after a mode switch has taken place and can notify window managers or other
39 # applications about it.
40 #
41 #
42 # While the script uses xrandr by default, calling it by the name "autodisper"
43 # or "auto-disper" forces it to use the "disper" utility, which is useful for
44 # controlling nvidia chipsets. The formats for fingerprinting the current setup
45 # and saving/loading the current configuration are adjusted accordingly.
46
47 XRANDR=/usr/bin/xrandr
48 DISPER=/usr/bin/disper
49 XDPYINFO=/usr/bin/xdpyinfo
50 PROFILES=~/.autorandr/
51 CONFIG=~/.autorandr.conf
52
53 CHANGE_PROFILE=0
54 FORCE_LOAD=0
55 DEFAULT_PROFILE=""
56 SAVE_PROFILE=""
57
58 FP_METHODS="setup_fp_xrandr_edid setup_fp_sysfs_edid"
59 CURRENT_CFG_METHOD="current_cfg_xrandr"
60 LOAD_METHOD="load_cfg_xrandr"
61
62 SCRIPTNAME="$(basename $0)"
63 # when called as autodisper/auto-disper, we assume different defaults
64 if [ "$SCRIPTNAME" = "auto-disper" ] || [ "$SCRIPTNAME" = "autodisper" ]; then
65         echo "Assuming disper defaults..." >&2
66         FP_METHODS="setup_fp_disper"
67         CURRENT_CFG_METHOD="current_cfg_disper"
68         LOAD_METHOD="load_cfg_disper"
69 fi
70
71 if [ -f $CONFIG ]; then
72         echo "Loading configuration from '$CONFIG'" >&2
73         . $CONFIG
74 fi
75
76 setup_fp_xrandr_edid() {
77         $XRANDR -q --verbose | awk '
78         /^[^ ]+ (dis)?connected / { DEV=$1; }
79         $1 ~ /^[a-f0-9]+$/ { ID[DEV] = ID[DEV] $1 }
80         END { for (X in ID) { print X " " ID[X]; } }'
81 }
82
83 setup_fp_sysfs_edid() {
84         # xrandr triggers the reloading of EDID data
85         $XRANDR -q > /dev/null
86         # hash the EDIDs of all _connected_ devices
87         for P in /sys/class/drm/card*-*/; do
88                 # nothing found
89                 [ ! -d "$P" ] && continue
90                 if grep -q "^connected$" < "${P}status"; then
91                         echo -n "$(basename "$P") "
92                         md5sum ${P}edid | awk '{print $1}'
93                 fi
94         done
95 }
96
97 setup_fp_disper() {
98         $DISPER -l | grep '^display '
99 }
100
101 setup_fp() {
102         local FP="";
103         for M in $FP_METHODS; do
104                 FP="$($M)"
105                 if [ -n "$FP" ]; then
106                         break
107                 fi
108         done
109         if [ -z "$FP" ]; then
110                 echo "Unable to fingerprint display configuration" >&2
111                 return
112         fi
113         echo "$FP"
114 }
115
116 current_cfg_xrandr() {
117         local PRIMARY_SETUP="";
118         if [ -x "$XDPYINFO" ]; then
119                 PRIMARY_SETUP="$($XDPYINFO -ext XINERAMA | awk '/^  head #0:/ {printf $3 $5}')"
120         fi
121         $XRANDR -q | awk -v primary_setup="${PRIMARY_SETUP}" '
122         # display is connected and has a mode
123         /^[^ ]+ connected [^(]/ {
124                 split($3, A, "+");
125                 print "output "$1;
126                 print "mode "A[1];
127                 print "pos "A[2]"x"A[3];
128                 if (A[1] A[2] "," A[3] == primary_setup)
129                         print "primary";
130                 next;
131         }
132         # disconnected or disabled displays
133         /^[^ ]+ (dis)?connected / ||
134         /^[^ ]+ unknown connection / {
135                 print "output "$1;
136                 print "off";
137                 next;
138         }'
139 }
140
141 current_cfg_disper() {
142         $DISPER -p
143 }
144
145 current_cfg() {
146         $CURRENT_CFG_METHOD;
147 }
148
149 blocked() {
150         local PROFILE="$1"
151         [ ! -x "$PROFILES/$PROFILE/block" ] && return 1
152
153         "$PROFILES/$PROFILE/block" "$PROFILE"
154 }
155
156 config_equal() {
157         local PROFILE="$1"
158         if [ "$(cat "$PROFILES/$PROFILE/config")" = "$(current_cfg)" ]; then
159                 echo "Config already loaded"
160                 return 0
161         else
162                 return 1
163         fi
164 }
165
166 load_cfg_xrandr() {
167         sed 's!^!--!' "$1" | xargs $XRANDR
168 }
169
170 load_cfg_disper() {
171         $DISPER -i < "$1"
172 }
173
174 load() {
175         local PROFILE="$1"
176         local CONF="$PROFILES/$PROFILE/config"
177         if [ -e "$CONF" ] ; then
178                 echo " -> loading profile $PROFILE"
179                 $LOAD_METHOD "$CONF"
180
181                 [ -x "$PROFILES/$PROFILE/postswitch" ] && \
182                         "$PROFILES/$PROFILE/postswitch" "$PROFILE"
183                 [ -x "$PROFILES/postswitch" ] && \
184                         "$PROFILES/postswitch" "$PROFILE"
185         fi
186 }
187
188 help() {
189         cat <<EOH
190 Usage: $SCRIPTNAME [options]
191
192 -h, --help              get this small help
193 -c, --change            reload current setup
194 -s, --save <profile>    save your current setup to profile <profile>
195 -l, --load <profile>    load profile <profile>
196 -d, --default <profile> make profile <profile> the default profile 
197 --force                 force (re)loading of a profile
198 --fingerprint           fingerprint your current hardware setup
199
200  To prevent a profile from being loaded, place a script call "block" in its
201  directory. The script is evaluated before the screen setup is inspected, and
202  in case of it returning a value of 0 the profile is skipped. This can be used
203  to query the status of a docking station you are about to leave.
204
205  If no suitable profile can be identified, the current configuration is kept.
206  To change this behaviour and switch to a fallback configuration, specify
207  --default <profile>.
208
209  Another script called "postswitch "can be placed in the directory
210  ~/.autorandr as well as in any profile directories: The scripts are executed
211  after a mode switch has taken place and can notify window managers.
212
213  When called by the name "autodisper" or "auto-disper", the script uses "disper"
214  instead of "xrandr" to detect, configure and save the display configuration.
215
216 EOH
217         exit
218 }
219 # process parameters
220 OPTS=$(getopt -n autorandr -o s:l:d:cfh --long change,default:,save:,load:,force,fingerprint,help -- "$@")
221 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
222 eval set -- "$OPTS"
223
224 while true; do
225         case "$1" in
226                 -c|--change) CHANGE_PROFILE=1; shift ;;
227                 -d|--default) DEFAULT_PROFILE="$2"; shift 2 ;;
228                 -s|--save) SAVE_PROFILE="$2"; shift 2 ;;
229                 -l|--load) LOAD_PROFILE="$2"; shift 2 ;;
230                 -h|--help) help ;; 
231                 --force) FORCE_LOAD=1; shift ;;
232                 --fingerprint) setup_fp; exit 0;;
233                 --) shift; break ;;
234                 *) echo "Error: $1"; exit 1;;
235         esac
236 done
237
238 CURRENT_SETUP="$(setup_fp)"
239
240 if [ -n "$SAVE_PROFILE" ]; then
241         echo "Saving current configuration as profile '${SAVE_PROFILE}'"
242         mkdir -p "$PROFILES/$SAVE_PROFILE"
243         echo "$CURRENT_SETUP" > "$PROFILES/$SAVE_PROFILE/setup"
244         $CURRENT_CFG_METHOD > "$PROFILES/$SAVE_PROFILE/config"
245         exit 0
246 fi
247
248 if [ -n "$LOAD_PROFILE" ]; then
249         CHANGE_PROFILE=1 FORCE_LOAD=1 load "$LOAD_PROFILE"
250         exit $?
251 fi
252
253 for SETUP_FILE in $PROFILES/*/setup; do
254         if ! [ -e $SETUP_FILE ]; then
255                 break
256         fi
257         PROFILE="$(basename $(dirname "$SETUP_FILE"))"
258         echo -n "$PROFILE"
259
260         if blocked "$PROFILE"; then
261                 echo " (blocked)"
262                 continue
263         fi
264
265         FILE_SETUP="$(cat "$PROFILES/$PROFILE/setup")"
266         if [ "$CURRENT_SETUP" = "$FILE_SETUP" ]; then
267                 echo " (detected)"
268                 if [ "$CHANGE_PROFILE" -eq 1 ]; then
269                         if [ "$FORCE_LOAD" -eq 1 ] || ! config_equal "$PROFILE"; then
270                                 load "$PROFILE"
271                         fi
272                 fi
273                 # found the profile, exit with success
274                 exit 0
275         else
276                 echo ""
277         fi
278 done
279
280 # we did not find the profile, load default
281 if [ -n "$DEFAULT_PROFILE" ]; then
282         echo "No suitable profile detected, falling back to $DEFAULT_PROFILE"
283         load "$DEFAULT_PROFILE"
284 fi
285 exit 1